<?php

    session_start();
    include("../DAO.php");

    function save(array $object) {

        $db = new DAO();
        $st = $db->prepare(
                "insert into users (name,
                        phone,email)
                 values(:name,:phone,:email)"
        );
        $params = array(
            ':name' => $object['name'],
            ':phone' => $object['phone'],
            ':email' => $object['email']
        );
        try {
            $st->execute($params);
            $_SESSION["login"] = true;
            return $db->lastInsertId();
        } catch (PDOException $e) {
            return "undefined";
        }
    }
    
    $name = $_POST['name'];
    $phone = $_POST['phone'];
    $email = $_POST['email'];

    $errors = "";
    
    $db = new DAO();
    // Select users where gain is not null
    $stmt = $db->prepare('SELECT * FROM users WHERE phone=? and gain is not NULL');
    $stmt->bindParam(1, $phone, PDO::PARAM_STR);
    $stmt->execute();
    $duplicatePhone = $stmt->fetch(PDO::FETCH_ASSOC);
    
    // Select users where gain is not null
    $stmt = $db->prepare('SELECT * FROM users WHERE name=? and gain is not NULL');
    $stmt->bindParam(1, $name, PDO::PARAM_STR);
    $stmt->execute();
    $duplicateName = $stmt->fetch(PDO::FETCH_ASSOC);
    
    if($duplicatePhone){
        $errors = "duplicatePhoneNumber";
    }
    if($duplicateName){
        if($errors != ""){
            $errors .= "_duplicateName";
        } else {
            $errors .= "duplicateName";
        }
    }
    
    if($errors == ""){
       // check if user exist with same data
        $stmt = $db->prepare("SELECT * FROM users WHERE phone=? and name=? and gain is NULL");
        $stmt->bindParam(1, $phone, PDO::PARAM_STR);
        $stmt->bindParam(2, $name, PDO::PARAM_STR);
        $stmt->execute();
        $users = $stmt->fetchAll();
        $currentUser = null;

        foreach($users as $user){
            $currentUser = $user['id'];
        }
        
        // if yes echo the user id
        if($currentUser != null){
            echo $currentUser;
        }
        // else create a new record with the new data
        else {
            echo save(array('name' => $name, 'phone' => $phone, 'email' => $email));
        }
        
        $_SESSION["login"] = true;
    } else {
        echo $errors;
    }
    

?>